/***Copyright and coded by Dakusan - See http://www.castledragmire.com/Copyright for more information. ***/
/***Dakusan's Action Counter - v1.0 http://www.castledragmire.com/Projects/Other_Web_Scripts#ActionCounter ***/

//Initialize the counter
function ActionCounter(IntervalValueID, LastActionID, TimeLeftID, UserAction)
{
	$CM(this, {IntervalTimeout:0, IntervalTime:0, IntervalCount:0, IsPerformingAction:false}); //Initial state information
	$CM(this, {IntervalValueO:$(IntervalValueID), LastActionO:$(LastActionID), TimeLeftO:$(TimeLeftID), UserAction:UserAction}); //Convert parameters to GUI Objects and callbacks

	//Set events for the interval value box
	var InputBoxCallBackFunc=CallObjFuncDynamic(this, 'GetActionIntervalValue');
	try {
		this.IntervalValueO.addEventListener('change', InputBoxCallBackFunc, true);
		this.IntervalValueO.addEventListener('input' , InputBoxCallBackFunc, true);
	} catch(E) {}
	this.IntervalValueO.onpropertychange=InputBoxCallBackFunc;

	//Initialize the interface
	this.GetActionIntervalValue();
	this.ExecuteAction();
}

//Common functions
var $   =function(O)		{return document.getElementById(O);};
var $I  =function(N)		{return parseInt(N, 10);};
var $CM =function(O,P)		{for(var i in P)if(P.hasOwnProperty(i))O[i]=P[i];return O;};

//Counter member functions
$CM(ActionCounter.prototype,
{
	//Force an action
	ExecuteAction:function()
	{
		if(!this.IsPerformingAction)
			this.ActionExecute();
	},

	//Update the inverval from a user defined value
	GetActionIntervalValue:function()
	{
		var OldInterval=this.IntervalTime;
		var NewInterval=$I(this.IntervalValueO.value);
		this.IntervalTime=NewInterval=(NewInterval>0 ? NewInterval : 0); //Force interval to be an integer greater than or equal to 0
		if(this.IsPerformingAction || NewInterval==OldInterval) //If already performing an action, or interval time has not changed, nothing left to do
			return;

		if(OldInterval!=0)
			clearInterval(this.IntervalTimeout);
		if(NewInterval!=0)
			this.IntervalTimeout=setInterval(CallObjFuncDynamic(this, 'UpdateIntervalCount'), 1000);
		this.IntervalCount=-1;
		this.UpdateIntervalCount();
	},

	//Update the counter and call update when interval count is hit
	UpdateIntervalCount:function()
	{
		if(this.IsPerformingAction)
			return clearInterval(this.UpdateIntervalCount);
		if(this.IntervalCount==Math.min(1,this.IntervalTime-1)) //Wait for up to 2 seconds before turning off class name
			this.LastActionO.className=this.LastActionO.className.replace(/ LastActionUpdated/g,'');
		if(++this.IntervalCount>=this.IntervalTime && this.IntervalTime!=0)
			return this.ActionExecute();

		this.TimeLeftO.innerHTML=Math.max(this.IntervalTime-this.IntervalCount, 0).toString();
	},

	//Execute the action
	ActionExecute:function()
	{
		if(this.IntervalTime!=0)
			clearInterval(this.IntervalTimeout);
		this.IsPerformingAction=true;
		this.TimeLeftO.innerHTML='Executing Action';
		this.TimeLeftO.className+=' TimeLeftUpdated';
		this.UserAction();
	},

	//Once an action has finished this needs to be called
	ActionFinished:function()
	{
		//Update GUI and return to previous state
		this.LastActionO.innerHTML=GetTimeString(new Date());
		this.LastActionO.className+=' LastActionUpdated';
		this.TimeLeftO.className=this.TimeLeftO.className.replace(/ TimeLeftUpdated/g,'');
		this.IsPerformingAction=false;
		if(this.IntervalTime!=0)
			this.IntervalTimeout=setInterval(CallObjFuncDynamic(this, 'UpdateIntervalCount'), 1000)
		this.IntervalCount=-1;
		this.UpdateIntervalCount();
	}
});

//Get pretty time function
function GetTimeString(T) { return new Date(T).toLocaleString().replace(/^.*?, /,'').replace(/GMT.*/, ''); }

function CallObjFuncDynamic(Obj, FuncName) { return function() { Obj[FuncName](); }; } //Call a member function of an object through an anonymous function