<?
//Return that this is in fact from the mapping API
header('Content-Type: text/plain; charset=utf-8');
print "MAPPING\n";

//Check variables
$ConfirmDouble='/^-?\d{1,3}\.\d{1,17}$/D'; //Degree format DDD.DDDDD, number of possible digits should only be 16 according to IEEE double format (52+1 bit significand=16 decimal digits), but my android passes 17...
$ConfirmFloat='/^-?\d{1,3}\.\d{1,9}$/D'; //See $ConfirmDouble description
$ConfirmTime='/^\d{1,13}$/D'; //ceil(log[10](2^32*1000))=13
$ConfirmUserName='/^[-A-Za-z0-9_ \\.]{1,25}$/D';
$ConfirmSHA1='/^[0-9A-F]{40}$/D'; //SHA1 as a 160bit hex string
$ConfirmationPatterns=Array('Latitude'=>$ConfirmDouble, 'Longitude'=>$ConfirmDouble, 'Altitude'=>$ConfirmDouble, 'Accuracy'=>$ConfirmFloat, 'Time'=>$ConfirmTime, 'UserName'=>$ConfirmUserName, 'Password'=>$ConfirmSHA1);
foreach($ConfirmationPatterns as $Name => $ConfirmationPattern) //Confirm if all the required variables are received and in the proper format
	if(!isset($_REQUEST[$Name]))
		ReturnMessage('Required variable not found: '.$Name);
	else if(preg_match($ConfirmationPattern, ${$Name}=$_REQUEST[$Name])==0)
		ReturnMessage('Variable is not in the proper format: '.$Name);

//Make sure variables are within proper ranges
if($Latitude>90 || $Latitude<-90 || $Longitude>180 || $Longitude<-180) //*Do we need sanity check for altitude?
	ReturnMessage('GPS coordinates are not within valid global coordinate ranges');
else if(abs($Time/1000-time())>24*60*60) //Make sure reported timestamp is within a 1 day range
	ReturnMessage('Timestamp is not within 24 hours of server time. Information ignored.');
else if($Accuracy<0)
	ReturnMessage('Accuracy cannot be less than 0');
if($Accuracy>100) //Make sure accuracy is within 100 meters
	print "Warning: Accuracy is greater than 100 meters\n";

//Attempt to update the user's information
include('../Config.php');
include('../Lib/SQL.php');
if(MysqlQuery('UPDATE Users SET Latitude=?, Longitude=?, Altitude=?, Accuracy=?, UserTime=?, RealTime=? WHERE UserName=? AND Password=? LIMIT 1', $Latitude, $Longitude, $Altitude, $Accuracy, intval($Time/1000, 10), time(), $UserName, $Password)->affected_rows!=1)
	if(($StoredPass=MysqlFetchData(MysqlQuery('SELECT Password FROM Users WHERE UserName=?', $UserName), 0))===FALSE)
		ReturnMessage('Username not found');
	else if($StoredPass!=$Password)
		ReturnMessage('Incorrect password');
print 'Position successfully updated';

function ReturnMessage($Msg)
{
	print $Msg;
	exit();
}
?>